<?php
//Version 05/05/2024  
ini_set('display_startup_errors', 1);
ini_set('display_errors', 1);
error_reporting(-1);
//error_reporting(E_ALL ^ E_NOTICE);//Informar de todos los errores menos notice, asi evito email con PHP Notice:  Undefined offset: 9 linea 26. Con @ delante de variable no notifica los NOTICE
///////////Configuracion////////////////////
$realtimefile = '/var/www/html/realtime.txt'; // Ruta absoluta realtime
//$realtimefile = '/var/www/html/script/realtime/realtimemod.txt'; // TEST
$realtimecachefile = '/var/www/html/script/alertalluvia.txt'; //el fichero se crea solo si no existe. Para prueba si el valor de lluvia es mayor de 0 eliminar fichero
$logFile = fopen("/var/www/html/script/log/errorscript.txt", 'a') or die("Error creando archivo"); //Fichero log
$umbraltormenta = 2; //umbral en l/m2 sobre el cual se considera tormenta
$tiempocomprobacion = 1; //minutos para la comprobación de la tormenta
$tiemporeanudacion = 120; //minutos comprobacion de reanudacion de lluvia
//$direccionaenviar = 'suemail@gmail.com'; //1 email
$direccionaenviar = "suemail@gmail.com,suemail@gmail.com";//2 o mas email
$test = false; //true, probar correo. false, no probar
$now = date('H:i:s');
$contenido = 'www.suweb.es'; //Añadir si queremos enviar contenido en el email
////////////////////////////////////////////

include('telegram.php'); //Incluimos configuracion de nuestro bot de telegram

// Lee el contenido del archivo para extraer fecha
$linea = file_get_contents ($realtimefile);
// Busca el patrón de fecha y hora en el contenido
$patron = '/(\d{2}\/\d{2}\/\d{2} \d{2}:\d{2}:\d{2})/';
if (preg_match($patron, $linea, $coincidencias)) {
$fechaActual = $coincidencias[1];
//$fechaActual ='27/04/24 00:00:05'; //TEST
}
//Ejecutamos una primera comprobacion que la fecha capturada es correcta si no lo esperamos 2 segundos y de nuevo la intentamos capturar, se intenta 2 veces si es correcta sigue y si no sale

$intentos = 0;
$maxIntentos = 2;
while(true) {
// Lee el contenido del archivo para extraer fecha
$linea = file_get_contents ($realtimefile);
// Busca el patrón de fecha y hora en el contenido
$patron = '/(\d{2}\/\d{2}\/\d{2} \d{2}:\d{2}:\d{2})/';
if (preg_match($patron, $linea, $coincidencias)) {
$fechaActual = $coincidencias[1];
//$fechaActual ='27/04/24 00:00:05'; //TEST
}
if(isset($fechaActual)) {
//echo "La variable ".$fechaActual." se definió.";
break; // Sal del bucle si la fecha está definida
} else {
if($intentos >= $maxIntentos) {
fwrite($logFile, "\n".date("d/m/Y H:i:s ")."Alertalluvia: fecha incorrecta") or die("Error escribiendo en el archivo");fclose($logFile);

//echo "La variable fechaActual".@$fechaActual." nunca se definió después de $maxIntentos intentos. Deteniendo script";

exit; // Sal del bucle si se supera el número máximo de intentos
}
sleep(2); // Espera 2 segundos
$intentos++;
}
}

$fechaDateTime = DateTime::createFromFormat('d/m/Y H:i:s', $fechaActual);
$horaActual = $fechaDateTime->format('H:i:s');
// Obtener el tiempo desde 00:00:00 hasta las 00:00:10
$tiempoespera = strtotime('00:00:10') - strtotime($horaActual);
if ($tiempoespera >= 0) {
sleep ($tiempoespera);// Pausa el script el tiempo indicad, asi evitamos falsa lluvia si realtime no estaba actualizado
}

if ($test) {mail($direccionaenviar, "Prueba", ''); exit;}

$mensaje = "";
 

$realtime = explode(' ', file_get_contents($realtimefile));
$fecha = explode('/', $realtime[0]);
$fechar = @$fecha[0].'-'.@$fecha[1].'-20'.@$fecha[2].' '.@$realtime[1];
$lluvia = @$realtime[9];
$fechart0 = @$realtime[0]; //Campo fecha
$fechart1 = @$realtime[1]; //Campo hora
//$lluvia = 1.0; // NULL para probar manual en falso. 
//$fechart0 = ('31/02/21');// Si desmarcamos nos dara falso si el valor manual tiene formato incorrecto
//$fechart1 = ('29:00:00');// Si desmarcamos nos dara falso si el valor manual tiene formato incorrecto
$fechart = ($fechart0.' '.$fechart1);
//El tiempo de reanudacion empieza a contar desde la ultima lluvia o cambio en el valor lluvia.

 
 
// Verificar si el valor es numérico si no lo es detiene el script
if (is_numeric($lluvia)) {
/*
echo "Hora actual: ".$now."\n";
echo "El valor de \$fechart0,\$fechart1 es: \n (".$fechart0.' '.$fechart1.")\n";//Imprime valor fecha y hora  correcto.
echo "El valor de \$lluvia es:\n (",$lluvia.")\n";
echo "Las variables son validas.\n";
*/
} else {
/*
echo "Hora actual: ".$now."\n";
echo "El valor de \$fechart0,\$fechart1 es: \n (".$fechart0.' '.$fechart1.") "; var_dump(($fechart));echo "";//Imprime valor fecha y hora .
echo "El valor de \$lluvia es: \n (",$lluvia.") ";var_dump(isset($lluvia));//Imprime valor lluvia .
echo "Una o las dos variables no son validas.\nDeteniendo el script.\n";
echo "El valor cache es $fechar,$lluvia \n";
echo "Error: El valor no es numérico";
*/
exit; 
}




if (!file_exists($realtimecachefile)) file_put_contents($realtimecachefile, $fechar.','.$lluvia);
$realtimecache = explode(',', file_get_contents($realtimecachefile));
$flaglluviacache = 0;
if (substr($realtimecache[0],0,2) != $fecha[0]) {file_put_contents($realtimecachefile, $fechar.',0.0'); $flaglluviacache = 1;}

$fecha = strtotime($fechar);

$fechacache = strtotime($realtimecache[0]);
$lluviacache = @$realtimecache[1];
if ($flaglluviacache) $lluviacache = "0.0";
$diff = $fecha - $fechacache;

$difflluvia = $lluvia - $lluviacache;

if ($lluvia == 0 or $difflluvia == 0) exit;
if ($lluviacache == 0 and $lluvia > 0) $mensaje = "Primera lluvia del día ".$lluvia." l  ".$now;
if ($difflluvia > 0 and $lluviacache > 0 and $diff >= $tiemporeanudacion * 60) $mensaje = "Vuelve a llover ".$lluvia." l  ".$now;
if ($difflluvia >= $umbraltormenta and $diff >= $tiempocomprobacion * 60) $mensaje = "Chaparron ".$lluvia." l  ".$now;
if ($difflluvia > 0 and $lluviacache > 0) $contenido = "";//
if ($difflluvia > 0 and $lluviacache > 0 and $diff >= $tiemporeanudacion * 60) $contenido = "www.suweb.es";//
if ($difflluvia >= $umbraltormenta and $diff >= $tiempocomprobacion * 60) $contenido = "www.suweb.es";//

file_put_contents($realtimecachefile, $fechar.','.$lluvia);

if ($mensaje) mail($direccionaenviar, $mensaje, $contenido); //enviamos email

 
 
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $urlMsg);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, "chat_id={$id}&parse_mode=HTML&text=$mensaje $contenido");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
 
$server_output = curl_exec($ch);
curl_close($ch);
 
?>